#include "keymap_common.h"

const uint8_t PROGMEM keymaps[][MATRIX_ROWS][MATRIX_COLS] = {

KEYMAP(
    A,    B,    C,    D,    E,    F,    G,    H,    I,    J,    K,    L,
    M,    N,    O,    P,    Q,    R,    S,    T,    U,    V,    W,    X,
    Y,    Z,    1,    2,    3,    4,    5,    6,    7,    8,    9,    0,
    F1,   F2,   F3,  F4,   F5,   F6,   F7,   F8,   F9,  F10,  F11,  F12,
    ENTER,ESC,BSPACE,TAB,SPACE,MINUS, EQUAL, LBRACKET, RBRACKET, BSLASH, SCOLON,QUOTE,
    GRAVE, COMMA, DOT, SLASH, PSCREEN, PAUSE, INSERT, HOME, PGUP, DELETE, END, PGDOWN,
    RIGHT, LEFT, DOWN, UP, KP_SLASH, KP_ASTERISK, KP_MINUS, KP_PLUS, KP_ENTER, KP_1, KP_2, KP_3,
    KP_4, KP_5, KP_6, KP_7, KP_8, KP_9, KP_0, KP_DOT, KP_EQUAL,KP_COMMA, AUDIO_MUTE, AUDIO_VOL_UP,
    AUDIO_VOL_DOWN,CAPSLOCK, SCROLLLOCK, NUMLOCK, LCTRL, LSHIFT, LALT,LGUI, RCTRL, RSHIFT, RALT, RGUI
),
};

const action_t PROGMEM fn_actions[] = {
	[0] = ACTION_LAYER_TAP_KEY(1, KC_SPACE),
	[1] = ACTION_LAYER_TAP_KEY(2, KC_BSPACE),
	[2] = ACTION_LAYER_TAP_KEY(3, KC_C),
	[3] = ACTION_LAYER_TAP_KEY(4, KC_V),
	[4] = ACTION_LAYER_TAP_KEY(5, KC_B),
	[5] = ACTION_MODS_TAP_KEY(MOD_RSFT, KC_ENT),
	[6] = ACTION_MODS_TAP_KEY(MOD_LCTL, KC_Z),
	[7] = ACTION_MODS_TAP_KEY(MOD_LALT, KC_X),
	[8] = ACTION_MODS_TAP_KEY(MOD_RALT, KC_N),
	[10] = ACTION_MODS_TAP_KEY(MOD_RCTL, KC_M),
	[11] = ACTION_MODS_KEY(MOD_LSFT, KC_1),
	[12] = ACTION_MODS_KEY(MOD_LSFT, KC_2),
	[13] = ACTION_MODS_KEY(MOD_LSFT, KC_3),
	[14] = ACTION_MODS_KEY(MOD_LSFT, KC_4),
	[15] = ACTION_MODS_KEY(MOD_LSFT, KC_5),
	[16] = ACTION_MODS_KEY(MOD_LSFT, KC_6),
	[17] = ACTION_MODS_KEY(MOD_LSFT, KC_7),
	[18] = ACTION_MODS_KEY(MOD_LSFT, KC_8),
	[19] = ACTION_MODS_KEY(MOD_LSFT, KC_9),
	[20] = ACTION_MODS_KEY(MOD_LSFT, KC_0),
	[21] = ACTION_MODS_KEY(MOD_LSFT, KC_MINS),
	[22] = ACTION_MODS_KEY(MOD_LSFT, KC_EQL),
	[23] = ACTION_MODS_KEY(MOD_LSFT, KC_LBRC),
	[24] = ACTION_MODS_KEY(MOD_LSFT, KC_RBRC),
	[25] = ACTION_MODS_KEY(MOD_LSFT, KC_BSLS),
	[26] = ACTION_MODS_KEY(MOD_LSFT, KC_COMM),
	[27] = ACTION_MODS_KEY(MOD_LSFT, KC_DOT),
	[28] = ACTION_MODS_KEY(MOD_LSFT, KC_SLSH),
	[29] = ACTION_MODS_KEY(MOD_LSFT, KC_SCLN),
	[30] = ACTION_MODS_KEY(MOD_LSFT, KC_QUOT),
};

